// Copyright (c) <2012> <Leif Asbrink>
//
// Permission is hereby granted, free of charge, to any person 
// obtaining a copy of this software and associated documentation 
// files (the "Software"), to deal in the Software without restriction, 
// including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of 
// the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be 
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
// OR OTHER DEALINGS IN THE SOFTWARE.



#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define WUSERHWDR 0
#define WDEPS1 1
#define USEREXTRA 2
#define DEPS3 3
#define WUSERHWDEF 4
#define WDEPS4 5
#define PALIR_DLL_OK 6
#define MAKELPA 7
#define PALINKDLL 8
#define WLINRAD_EXE 9
#define LLINRAD_EXE 10
#define LUSERHWDR 11
#define LUSERHWDEF 12
#define DEPS2 13
#define PERSEUS 14
#define LIBUSB_WIN_OK 15
#define LIBUSB_LN 16
#define M32 17
#define SOFT66_WIN_OK 18
#define SOFT66_WIN_LN 19
#define LIBFTDI_WIN_OK 20
#define LIBFTDI_WIN_LN 21
#define LIBUSB1_WIN_OK 22
#define LIBUSB1_WIN_LN 23
#define LIBRTLSDR_WIN_OK 24
#define LIBRTLSDR_WIN_LN 25
#define SERVER 26
#define NO_OF_REPLACE 27

char *input_string[NO_OF_REPLACE]={"@WUSERHWDR@",          //0
                                   "@WDEPS1@",             //1
                                   "@USEREXTRA@",          //2
                                   "@DEPS3@",              //3
                                   "@WUSERHWDEF@",         //4
                                   "@WDEPS4@",             //5
                                   "@PALIR_DLL_OK@",       //6
                                   "@MAKELPA@",            //7
                                   "@PALINKDLL@",          //8
                                   "@WLINRAD_EXE@",        //9
                                   "@LLINRAD_EXE@",        //10
                                   "@LUSERHWDR@",          //11
                                   "@LUSERHWDEF@",         //12
                                   "@DEPS2@",              //13
                                   "@PERSEUS@",            //14
                                   "@LIBUSB_WIN_OK@",      //15
                                   "@LIBUSB_LN@",          //16
                                   "@M32@",                //17
                                   "@SOFT66_WIN_OK@",      //18
                                   "@SOFT66_WIN_LN@",      //19
                                   "@LIBFTDI_WIN_OK@",     //20
                                   "@LIBFTDI_WIN_LN@",     //21
                                   "@LIBUSB1_WIN_OK@",     //22
                                   "@LIBUSB1_WIN_LN@",     //23
                                   "@LIBRTLSDR_WIN_OK@",   //24
                                   "@LIBRTLSDR_WIN_LN@",   //25
                                   "@SERVER@"};            //26
                                   
char *output_string[NO_OF_REPLACE];

void replace(char *s, int *len)
{
int i, j, k;
int m,l1,l2;
for(j=0; j<NO_OF_REPLACE; j++)
  {
  l1=strlen(input_string[j]);
  l2=strlen(output_string[j]);
printf("\n%s -> %s",input_string[j],output_string[j]);
  m=l1-l2;
  i=0;
nxt_i:;  
  while(i <= len[0] && s[i]!=input_string[j][0])i++;
  k=0;
  while( k+i <= len[0] && 
         s[i+k]==input_string[j][k] && 
         input_string[j][k] != 0)k++;
  if(input_string[j][k] == 0)
    {
    len[0]-=m;
    if(m>0)
      {
      k=i;
      while(k < len[0])
        {
        s[k]=s[k+m];
        k++;
        }
      }
    else
      {
      k=len[0];
      while(k > i)
        {
        k--;
        s[k]=s[k+m];
        }
      }
    k=0;  
    while(k<l2)
      {
      s[i]=output_string[j][k];
      i++;
      k++;
      }
    }
  else
    {
    i++;
    }
  if(i<len[0])goto nxt_i;  
  }  
}

int main(int argc, char *argv[])
{
FILE *file;
char *s;
int i, j;
int soft66_warning, libusb_warning, portaudio_warning, elektor_warning;
int libusb1_warning, librtlsdr_warning;
(void) *argv;
(void) argc;
libusb_warning=1;
libusb1_warning=1;
portaudio_warning=1;
soft66_warning=1;
elektor_warning=1;
librtlsdr_warning=1;
s=malloc(0x40000);
if(s == NULL)
  {
  printf("\nERROR: could not allocate memory");
  exit(0);
  } 
for(j=0; j<NO_OF_REPLACE; j++)
  {
  output_string[j]="";
  }
// Set up the strings we want to replace the input strings with.
file=fopen("wusers_hwaredriver.c","r");
if(file != NULL)
  {
  output_string[WUSERHWDR]="1";
  output_string[WDEPS1]="wusers_hwaredriver.c";
  fclose(file);
  }
file=fopen("users_extra.c","r");
if(file != NULL)
  {
  output_string[USEREXTRA]="1";
  output_string[DEPS3]="users_extra.c";
  fclose(file);
  }
file=fopen("wusers_hwaredef.h","r");
if(file != NULL)
  {
  output_string[WUSERHWDEF]="1";
  output_string[WDEPS4]="wusers_hwaredef.h";
  fclose(file);
  }
output_string[MAKELPA]="0"; 
output_string[WLINRAD_EXE]="linrad.exe";
output_string[LLINRAD_EXE]="for_linux";  
output_string[PALIR_DLL_OK]="0";  
output_string[PALINKDLL]="";
file=fopen("palir-01.dll","r");
  {
  if(file != NULL)
    {
    fclose(file);
    output_string[PALIR_DLL_OK]="1";  
    output_string[PALINKDLL]="palir-01.dll";
    portaudio_warning=0;
    }
  }  
file=fopen("palir-02.dll","r");
  {
  if(file != NULL)
    {
    fclose(file);
    output_string[PALIR_DLL_OK]="1";  
    output_string[PALINKDLL]="palir-02.dll";
    portaudio_warning=0;
    }
  }  
output_string[LIBUSB_WIN_OK]="0";  
output_string[SOFT66_WIN_OK]="0";  
output_string[LIBFTDI_WIN_OK]="0";
file=fopen("C:\\mingw\\include\\usb.h","r");
  {
  if(file != NULL)
    {
    fclose(file);
    file=fopen("C:\\mingw\\lib\\libusb.a","r");
    if(file != NULL)
      {
      fclose(file);
      output_string[LIBUSB_WIN_OK]="1";
      output_string[LIBUSB_LN]="-lusb";
      libusb_warning=0;
      file=fopen("C:\\mingw\\include\\ftdi.h","r");
        {
        if(file != NULL)
          {
          fclose(file);
          file=fopen("C:\\mingw\\lib\\libftdi.a","r");
          if(file != NULL)
            {
            fclose(file);
            output_string[LIBFTDI_WIN_OK]="1";
            output_string[LIBFTDI_WIN_LN]="-lftdi";
            elektor_warning=0;
            file=fopen("C:\\mingw\\include\\soft66.h","r");
              {
              if(file != NULL)
                {
                fclose(file);
                file=fopen("C:\\mingw\\lib\\libsoft66.a","r");
                if(file != NULL)
                  {
                  fclose(file);
                  output_string[SOFT66_WIN_OK]="1";
                  output_string[SOFT66_WIN_LN]="-lsoft66";
                  soft66_warning=0;
                  }
                }
              }    
            }
          }
        }
      }
    }
  }        
output_string[LIBUSB1_WIN_OK]="0";
output_string[LIBRTLSDR_WIN_OK]="0";
file=fopen("C:\\mingw\\include\\libusb-1.0\\libusb.h","r");
  {
  if(file != NULL)
    {
    fclose(file);
    file=fopen("C:\\mingw\\lib\\libusb-1.0.a","r");
    if(file != NULL)
      {
      fclose(file);
      output_string[LIBUSB1_WIN_OK]="1";
      output_string[LIBUSB1_WIN_LN]="-lusb-1.0";
      libusb1_warning=0;
      file=fopen("C:\\mingw\\include\\rtl-sdr.h","r");
        {
        if(file != NULL)
          {
          fclose(file);
          file=fopen("C:\\mingw\\lib\\librtlsdr.a","r");
          if(file != NULL)
            {
            fclose(file);
            output_string[LIBRTLSDR_WIN_OK]="1";
            output_string[LIBRTLSDR_WIN_LN]="-lrtlsdr";
            librtlsdr_warning=0;
            }
          }
        }  
      }
    }
  }    
// ***************************************************
output_string[SERVER]="0";



file=fopen("conf.h.in","r");
if(file == NULL)
  {
  printf("Could not open file: conf.h.in\n");
  exit(0);
  }
j=0;
i=1;
while(i != 0 && j< 0x3ffff)
  {  
  i=fread(&s[j],1,1,file);
  j++;
  }
j--;  
printf("\nReading %d bytes from conf.h.in",j);
fclose(file);
replace(s, &j);
file=fopen("conf.h","w");
if(file == NULL)
  {
  printf("\nCould not open conf.h for write");
  exit(0);
  }
i=fwrite(s,j,1,file);
fclose(file);
printf("\n%d bytes written to conf.h",j);
if(i!=1)
  {
  printf("\nERROR Buffer only written in part");
  exit(0);
  }
// ***************************************************
file=fopen("Makefile.in","r");
if(file == NULL)
  {
  printf("\nCould not open file: Makefile.in\n");
  exit(0);
  }
j=0;
i=1;
while(i != 0 && j< 0x3ffff)
  {  
  i=fread(&s[j],1,1,file);
  j++;
  }
j--;  
printf("\nReading %d bytes from Makefile.in",j);
fclose(file);
replace(s, &j);
file=fopen("Makefile","w");
if(file == NULL)
  {
  printf("\nCould not open Makefile for write");
  exit(0);
  }
i=fwrite(s,j,1,file);
fclose(file);
printf("\n%d bytes written to Makefile",j);
if(i!=1)
  {
  printf("\nERROR Buffer only written in part");
  exit(0);
  }
if(portaudio_warning != 0)
  {
  printf("\n\nThe file palir-xx.dll is missing in the Linrad directory");
  printf("\nWill compile without Portaudio.");
  }
if(libusb_warning != 0)
  {
  printf("\n\nusb.h and/or libusb.a are missing in your mingw directory");
  printf("\nWill compile without support for Si570 (Softrock and others)."); 
  }
if(libusb1_warning != 0)
  {
  printf("\n\nOne or more of the following files are missing in your mingw");
  printf("\ndirectory:  libusb-1.0\\libusb.h libusb.h libusb-1.0.a"); 
  printf("\nWill compile without support RTL2832 and others)."); 
  }
if(soft66_warning != 0)
  {
  printf("\n\nOne or more of the following files are missing in your mingw");
  printf("\ndirectory:  usb.h ftdi.h soft66.h libftdi.a libsoft66.a libusb.a");
  printf("\nWill compile without support for soft66 radios."); 
  }
if(elektor_warning != 0)
  {
  printf("\n\nOne or more of the following files are missing in your mingw");
  printf("\ndirectory:  usb.h ftdi.h libftdi.a libusb.a");
  printf("\nWill compile without support for elektor radios."); 
  }
if(librtlsdr_warning != 0)
  {
  printf("\n\nOne or more of the following files are missing in your mingw");
  printf("\ndirectory:  rtl-sdr.h librtlsdr.a libusb-1.0\\libusb.h libusb.h");
  printf("\nlibusb-1.0.a ");
  printf("\nWill compile without support for rtl-sdr dongles."); 
  }
free(s);
return 0;  
}
